package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZAPPCTRL;
import cn.ibizlab.core.sample.filter.IBIZAPPCTRLSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.alibaba.fastjson.JSONObject;

public interface IBIZAPPCTRLMapper extends BaseMapper<IBIZAPPCTRL> {


    Page<IBIZAPPCTRL> searchDefault(IPage page, @Param("ctx") IBIZAPPCTRLSearchContext context, @Param("ew") Wrapper<IBIZAPPCTRL> wrapper);
    List<IBIZAPPCTRL> listDefault(@Param("ctx") IBIZAPPCTRLSearchContext context, @Param("ew") Wrapper<IBIZAPPCTRL> wrapper);

    @Override
    IBIZAPPCTRL selectById(Serializable id);

    IBIZAPPCTRL selectEntity(IBIZAPPCTRL entity);

    List<IBIZAPPCTRL> selectEntities(@Param("list") List<IBIZAPPCTRL> list);

    @Override
    int insert(IBIZAPPCTRL entity);

    @Override
    int updateById(@Param(Constants.ENTITY) IBIZAPPCTRL entity);

    @Override
    int update(@Param(Constants.ENTITY) IBIZAPPCTRL entity, @Param("ew") Wrapper<IBIZAPPCTRL> updateWrapper);

    @Override
    int deleteById(Serializable id);

    int deleteEntities(@Param("list") List<IBIZAPPCTRL> list);

    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);


}